/// O(NlogN)
#include<bits/stdc++.h>
using namespace std;
const long long mod=1e9+7;
long long binpow(long long num, long long p) {
    if(p==0)return 1;
    if(p&1) return (binpow(num,p-1)*num)%mod;
    const long long temp=binpow(num, p/2);
    return (temp*temp)%mod;
}
long long inverse(long long num) {
    return binpow(num, mod-2);
}

bool check(long long hashes[], int from, int to, long long revpow[], long long mod) {
    long long cursum=hashes[to];
    cursum-=hashes[from-1];
    cursum+=mod;
    cursum%=mod;
    cursum*=revpow[from-1];
    cursum%=mod;
    return cursum==hashes[to-from+1];
}
/// taken from cp-algorithms.com
vector<int> prefix_function(string s) {
    int n=s.size();
    std::vector<long long> hashesV(s.size() + 1);
    long long* hashes = hashesV.data();
    long long cur=0;
    long long mul=1;
    long long base=10000019;
    long long mod=1e9+7;
    for(int i=0;i<n;i++) {
        mul*=base;
        mul%=mod;
        cur+=mul*s[i];
        cur%=mod;
        hashes[i+1]=cur;
    }
    long long revpow[n+1];
    revpow[0]=1;
    revpow[1]=inverse(base);
    for(int i=2;i<=n;i++) {
        revpow[i]=revpow[i-1]*revpow[1];
        revpow[i]%=mod;
    }
    vector<vector<int>> sets(n + 1);
    for(int i=1;i<=n;i++) {
        if(s[i-1]!=s[0])continue;
        int l=i,r=n+1;
        while(l+1<r) {
            int mid=(l+r)/2;
            if(check(hashes, i, mid, revpow, mod))l=mid;
            else r=mid;
        }
        sets[l].push_back(i-1);
    }
    set<int>curs;
    vector<int>ans(n,0);
    for(int i=1;i<n;i++) {
        if(s[i]==s[0])curs.insert(i);
        for(int j:sets[i])curs.erase(j);
        if(curs.size()!=0) {
            int mini=*curs.begin();
            ans[i]=i-mini+1;
        }
    }
    return ans;
}

vector<int> get_positions(string s) {
    int n=s.size();
    vector<int> ans(n,0);
    vector<int> kmp = prefix_function(s);
    for(int i=1;i<n;i++) {
        int val=kmp[i-1];
        if(s[val]!=s[i])ans[i]=val+1;
        else ans[i]=ans[val];
    }
    return ans;
}


void solve() {
    int n;cin>>n;

    long long pA;cin>>pA;
    long long pB;cin>>pB;
    const long long p=(pA*inverse(pB))%mod;
    const long long one_minus_p = ((1LL-p+mod))%mod;
    const long long one_over_p = inverse(p);
    const long long one_over_one_minus_p = inverse(one_minus_p);

    string s;cin>>s;
    vector<int>prev = get_positions(s);
    vector<long long>b(n+1,0);
    long long denom = 1;
    for(int i=0;i<n;i++) {
        long long curp=p;
        long long curdenom=one_over_one_minus_p;
        if(s[i]=='0') {
            curp = one_minus_p;
            curdenom = one_over_p;
        }
        long long num = b[i]-curp*b[prev[i]]-1;
        num=(num%mod)+mod;
        if(i+1==n)denom *= curdenom;
        b[i+1] = (num*curdenom)%mod;
    }
    denom = inverse(denom);
    long long numm=(-b[n]+mod)%mod;
    cout<<numm<<endl;
}
int main() {
    ios_base::sync_with_stdio(0);cin.tie(0);
    solve();
    return 0;
}
