#include<bits/stdc++.h>
using namespace std;
const long long mod=1e9+7;
long long binpow(long long num, long long p) {
    if(p==0)return 1;
    if(p&1) return (binpow(num,p-1)*num)%mod;
    const long long temp=binpow(num, p/2);
    return (temp*temp)%mod;
}
long long inverse(long long num) {
    return binpow(num, mod-2);
}
vector<int> get_positions(string s) {
    int n=s.size();
    vector<int>ans(n, 0);
    for(int i=0;i<n;i++) {
        for(int j=i;j<n;j++) {
            if(s[j-i]!=s[j]) {
                ans[j]=max(ans[j], j-i+1);
                break;
            }
        }
    }
    return ans;
}
void perform_magic(vector<vector<long long>>&a, int n) {
    for(int i=0;i<n;i++) {
        int ind=-1;
        for(int j=0;j<n;j++) {
            if(a[j][i]!=0)ind=j;
        }
        if(ind!=i)swap(a[ind],a[i]);
        ind=i;
        long long curn=inverse(a[ind][i]);
        for(int j=0;j<=n;j++)a[ind][j]=(a[ind][j]*curn)%mod;
        for(int j=0;j<n;j++) {
            if(j==ind)continue;
            long long to_remove=a[j][i];
            for(int k=0;k<=n;k++) {
                a[j][k]-=to_remove*a[ind][k];
                a[j][k]%=mod;
                a[j][k]+=mod;
                a[j][k]%=mod;
            }
        }
    }
}
void solve() {
    int n;cin>>n;

    long long pA;cin>>pA;
    long long pB;cin>>pB;
    const long long p=(pA*inverse(pB))%mod;
    const long long one_minus_p = ((1LL-p+mod))%mod;
    const long long one_over_p = inverse(p);
    const long long one_over_one_minus_p = inverse(one_minus_p);

    string s;cin>>s;
    vector<vector<long long>>mat;
    vector<int>prev = get_positions(s);
    for(int i=0;i<n;i++) {
        vector<long long>row(n+2,0);
        long long curp=p;
        if(s[i]=='1') {
            curp = one_minus_p;
        }
        row[i]=1;
        row[prev[i]]+=(curp-1LL);
        row[i+1]=-curp;
        row[n+1]=1;
        mat.push_back(row);
    }
    vector<long long>row(n+2,0);
    row[n]=1;
    mat.push_back(row);
    perform_magic(mat, n+1);
    cout<<mat[0][n+1]<<endl;
}
int main() {
    ios_base::sync_with_stdio(0);cin.tie(0);
    solve();
    return 0;
}
