#include<bits/stdc++.h>

#define MOD 1000000007

int64_t fastpow(int64_t b, int64_t e) {
	int64_t ans = 1;

	while (e) {
		if (e & 1) ans = ans * b % MOD;
		b = b * b % MOD;
		e = e >> 1;
	}

	return ans;
}

void sol() {
	size_t n; std::cin >> n;

	int64_t q1; std::cin >> q1;
	int64_t q2; std::cin >> q2;

	int64_t p0 = q1 * fastpow(q2, MOD-2) % MOD;
	int64_t p1 = (1 + MOD - p0) % MOD;

	std::vector<size_t> s(n);
	for (size_t i = 0; i < n; i += 1) {
		char c; std::cin >> c;
		s[i] = c - '0';
	}

	std::vector<size_t> kmp(n);
	for (size_t i = 0; i < n; i += 1) {
		size_t j = i;
		kmp[i] = 0;
		while (j != 0) {
			j = kmp[j-1];
			if (s[j] == s[i]) {
				kmp[i] = j+1;
				break;
			}
		}
	}

	std::vector<std::array<size_t, 2>> next(n);
	next[0][s[0]  ] = 1;
	next[0][s[0]^1] = 0;

	for (size_t i = 1; i < n; i += 1) {
		next[i][s[i]  ] = i + 1;
		next[i][s[i]^1] = next[kmp[i-1]][s[i]^1];
	}

	std::vector<int64_t> pfx(n+1);
	pfx[0] = 0;

	int64_t coef[2] = {
		p1 * fastpow(p0, MOD-2) % MOD,
		p0 * fastpow(p1, MOD-2) % MOD,
	};

	for (size_t i = 0; i < n; i += 1) {
		int64_t r = (1 + pfx[i] - pfx[next[i][s[i]^1]] + MOD) % MOD;
		pfx[i+1] = (pfx[i] + 1 + r * coef[s[i]]) % MOD;
	}
	std::cout << pfx[n] << "\n";
}

int main() {
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	sol();
}
