import os
import subprocess

def compile_and_run_tests():
    folder = 'tests'#input("Enter the folder containing .in files: ")
    cpp_program = 'author/author'#input("Enter the C++ program name (without .cpp extension): ")
    
    cpp_file = f"{cpp_program}.cpp"
    executable = f"{cpp_program}.exe" if os.name == "nt" else f"{cpp_program}"  # Windows vs Linux/Mac
    
    # Compile the C++ program
    compile_command = ["g++", "-o", executable, cpp_file]
    compile_result = subprocess.run(compile_command, capture_output=True, text=True)
    
    if compile_result.returncode != 0:
        print("Compilation failed:")
        print(compile_result.stderr)
        return
    
    print("Compilation successful!")
    
    # Find all .in files in the given folder
    for file in os.listdir(folder):
        if file.endswith(".in"):
            test_name = os.path.splitext(file)[0]
            input_file = os.path.join(folder, file)
            output_file = os.path.join(folder, f"{test_name}.sol")
            
            with open(input_file, "r") as infile, open(output_file, "w") as outfile:
                subprocess.run([f"./{executable}"], stdin=infile, stdout=outfile, text=True)
    
    print("Test execution completed! Output files have been created.")

if __name__ == "__main__":
    compile_and_run_tests()